﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;
using FeatureDetectors;
using System.Windows.Forms;
using Emgu.CV;
using Emgu.CV.Structure;
using Emgu.CV.CvEnum;
using SURF;

namespace FeatureDetectors {
	public class SURFOptions : CDetectorOptions {
		public double hessianThreshold = 500;
		public int extended = 0;
		public int octaves = 3;
		public int layers = 4;
		
	}
	public class CDetectorFunc : CDetector {
		public override string detectorName { get { return "SURF"; } }
		private OptionsDialog optDialog;

		public CDetectorFunc() {
			options = new SURFOptions();
			optDialog = new OptionsDialog((SURFOptions) options);
		}
		override public DialogResult ShowOptionsDialog() {
			optDialog.Show();
			optDialog.Activate();
			return DialogResult.OK;
		}
		override public  Feature[] GetFeatures(Image<Gray, byte> image) {
		
            #region extract features from the object image
            MCvSURFParams myParams = new MCvSURFParams();
			myParams.hessianThreshold = ((SURFOptions) options).hessianThreshold;
			myParams.extended = ((SURFOptions) options).extended;
			myParams.nOctaves = ((SURFOptions) options).octaves;
			myParams.nOctaveLayers = ((SURFOptions) options).layers;
			//return new Feature[0];
            SURFFeature[] features = image.ExtractSURF(ref myParams);

			Feature[] result = new Feature[features.Length];
			int index = 0;
			foreach ( SURFFeature ff in features ) result[index++] = new Feature(ff);
			#endregion

			return result;
			//return new Feature[0];
			
        }
	}
}
